SystemOrganization addCategory: #'SPAWorkshop-Tutorial'!
SystemOrganization addCategory: #'SPAWorkshop-Exercise'!

Tutorial subclass: #SpaTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Tutorial'!

!SpaTutorial class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 6/28/2012 23:03'!
title
	^'Legacy Data and Code Visualization with Moose'! !

!SpaTutorial methodsFor: 'browsers' stamp: 'StephanEggermont 6/28/2012 23:12'!
allExamples 
	^ Pragma allNamed: #glmBrowser:input: in: GLMBasicExamples! !

!SpaTutorial methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:44'!
eggRaceClasses
	^(PackageInfo allPackages detect: [ :p | p packageName beginsWith: 'EggRace' ]) classes! !

!SpaTutorial methodsFor: 'eyesee' stamp: 'StephanEggermont 7/1/2012 15:48'!
eyesee
	^TutorialText new
	title: 'EyeSee';
	text: 
'EyeSee is a framework to draw and layout business graphs.

It can draw bardiagrams, linediagrams, piecharts, ';

	children: #(eyeseeBarDiagram eyeseeExercise1 )! !

!SpaTutorial methodsFor: 'eyesee' stamp: 'StephanEggermont 7/1/2012 13:06'!
eyeseeBarDiagram
	^TutorialCustomAndSource new
	title: 'Example ';
	presentation: [	| browser |
	browser := GLMTabulator new.
	browser row: #one span: 3; row: #two.
	browser transmit to: #one; andShow: [:a |
	       a eyesee
			title: 'Sample bar chart';
			diagram: [:renderer :x |
	                       renderer verticalBarDiagram
						y: #yourself;
						models: x;
						width: 200;
						height: 150;
						baseAxisLine.
					renderer interaction popupText: #yourself ]].
	browser transmit from: #one; to: #two; andShow: [:a | 
		a text
			title: 'Preview'].
	browser startOn: #(5 2 10 6 12 8 7 8 5 3 8 4 2 4 9 7).
	browser]! !

!SpaTutorial methodsFor: 'eyesee' stamp: 'StephanEggermont 7/1/2012 13:20'!
eyeseeExercise1
	^TutorialExercise new
	title: 'Commit size exercise';
	textTitle: 'Source';
	text: (SpaEyeseeExercise methodDict at: #exercise1) getSource;
	assignment: 'Here you see the size of each commit done by a commiter.
	
If no committer is selected, we''d like to see the same for all commits of the projects.
	
You need to add a new transmission with the selection from the project';
	smalltalkClass: SpaEyeseeExercise;
	target: ERModel default;
	presentation: SpaEyeseeExercise new exercise1! !

!SpaTutorial methodsFor: 'browsers' stamp: 'StephanEggermont 7/1/2012 17:29'!
furtherReading
	^TutorialText new
	title: 'Further reading';
	text: 
'The code for this tutorial can be found at

http://ss3.gemstone.com/SpaTutorial

The MOOSE environment can be found at

http://www.moosetechnology.org

The book on MOOSE is

http://www.moosebook.org

The MOOSE framework builds on top of the Pharo Smalltalk environment.
The Pharo environment is found at:

http://www.pharoproject.org

The book explaining how to use Pharo is

http://www.pharobyexample.org.

Robert Chatley wrote on the SPA2011 egg race at

http://chatley.com/posts/06-20-2011/spa-great-egg-race/

The code written by Micheal Feathers to extract data from git repositories

https://github.com/michaelfeathers/repodepot-ruby';
children: #(moreExamples)! !

!SpaTutorial methodsFor: 'glamour' stamp: 'StephanEggermont 7/1/2012 17:32'!
glamour
	^TutorialText new
	title: 'Glamour';
	text: 
'Glamour is a framework to build model browsers.';
	children: #(glamourConcepts #glamourExercises)! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 14:19'!
glamourConcepts
	^TutorialText new
	title: 'Concepts';
	text: 
'- Layout.
- Panes.
- Navigation.';
	children: #(glamourLayout glamourPanes glamourParameters glamourNavigation)! !

!SpaTutorial methodsFor: 'glamour' stamp: 'StephanEggermont 6/29/2012 00:30'!
glamourDiff
	^TutorialCustom new
	title: 'Method diff';
	presentation: [TestBrowser diff]! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'StephanEggermont 7/1/2012 17:33'!
glamourExercise1
	^TutorialExercise new
	title: 'Format project title';
	textTitle: 'Source';
	text: (SpaGlamourExercise methodDict at: #exercise1) getSource;
	assignment: 'We would like to modify the way these projects are shown
	
At the moment, the (default) printString method of ERProject is used.
(ERProject is a class in the EggRace package.). Use a system browser to view this code.
Use a system browser to edit the code for this exercise: 

SpaGlamourExercise>glamourExercise1 (in package SPAWorkshop-Exercise)

You can type a class name in the search bar of the system window to find it.
	
Add a format block to use the projectTitleString method.

When you are done, the projects tab should show the number of committers and commits in addition to the project title.

see Glamour/Concepts/Parameters for an example';
	smalltalkClass: SpaGlamourExercise;
	target: ERModel default;
	presentation: SpaGlamourExercise new exercise1! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'StephanEggermont 7/1/2012 19:15'!
glamourExercise2
	^TutorialExercise new
	title: 'Info for team members';
	textTitle: 'Source';
	text: (SpaGlamourExercise methodDict at: #exercise2) getSource;
	assignment: 'We would like to see some details about the team members
	
At the moment, the info won''t be filled when a team member is clicked, only when a project is clicked.
	
Add a transmit from the element to the info block. You should display the info of the committer (team member).

';
	smalltalkClass: SpaGlamourExercise;
	target: ERModel default;
	presentation: SpaGlamourExercise new exercise2! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'DiegoLont 6/29/2012 16:23'!
glamourExercise3
	^TutorialExercise new
	title: 'Show commits of team';
	textTitle: 'Source';
	text: (SpaGlamourExercise methodDict at: #exercise3) getSource;
	assignment: 'We would like to be able to browse all files (entries) of a project.
	
At the moment, the team is shown as a list. This should be made into a tree, with the correct children.
	
Change the pane type for the element into a tree, and add the children message.';
	smalltalkClass: SpaGlamourExercise;
	target: ERModel default;
	presentation: SpaGlamourExercise new exercise3! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'DiegoLont 6/29/2012 16:19'!
glamourExercise4
	^TutorialExercise new
	title: 'Complexity';
	textTitle: 'Source';
	text: (SpaGlamourExercise methodDict at: #exercise4) getSource;
	assignment: 'We would like to have more information about the complexity of methods and classes
	
At the moment, the info only shows the number of methods. And you can only browse files. Make it possible to view the complexity of methods and classes.
	
For a solution we have the following suggestions:
	1. Add a pane where you display the classes and methods in a file. When selecting a class or method display the info, this shows the complexity range. The info of class is not yet implemented. Look at the code for a method to make the one for a class.
	2. Extend the info of files where you also give details about the classes and methods in this file.
Try one of these two solutions.';
	smalltalkClass: SpaGlamourExercise;
	target: ERModel default;
	presentation: SpaGlamourExercise new exercise4! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'DiegoLont 6/29/2012 15:34'!
glamourExercise5
	^TutorialExercise new
	title: 'Format project title';
	textTitle: 'Source';
	text: (SpaGlamourExercise methodDict at: #exercise5) getSource;
	assignment: 'We would like to modify the way these projects are shown
	
At the moment, the (default) printString method of ERProject is used.
	
Add a format block to use the projectTitleString method ';
	smalltalkClass: SpaGlamourExercise;
	target: ERModel default;
	presentation: SpaGlamourExercise new exercise5! !

!SpaTutorial methodsFor: 'glamourExercises' stamp: 'StephanEggermont 6/29/2012 18:03'!
glamourExercises
	^TutorialText new
		title: 'Exercises';
		text: 
'We''ll work from (a modified version of) last year''s great egg race.

It contains commit data from the git repositories of 4 ruby projects: 
- eventmachine
- active_merchant
- diaspora
- paperclip

The data is provided as a csv file / project
It starts with a line with field names
Each line consists of 8 fields
date, commit, committer, file_name, line_count, class_name,method_name, complexity

';
	children: #( glamourExercise1 glamourExercise2 glamourExercise3 glamourExercise4 )! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 15:52'!
glamourLayout
	^TutorialCustomAndText new
	title: 'Layout';
	textTitle: 'Source';
	text: (self class methodDict at: #glamourLayoutBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self glamourLayoutBrowser ]! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 11:41'!
glamourLayoutBrowser
	| browser |
	browser := GLMTabulator new.
	browser row: [ :r | r column: #one; column: #two; column: #three ] span: 3; row: #four.
	browser transmit to: #one; andShow: [ :a | a text display: 'This is pane one. It is this first column of the first row.'].
	browser transmit to: #two; andShow: [ :a | a text display: 'This is pane two. It is this second column of the first row.'].
	browser transmit to: #three; andShow: [ :a | a text display: 'This is pane three. It is this third column of the first row.'].
	browser transmit to: #four; andShow: [ :a | a text display: 'This is pane four. It is this second row and has no columns.'].
	browser startOn: self.
	^browser
! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 15:52'!
glamourNavigation
	^TutorialCustomAndText new
	title: 'Navigation';
	textTitle: 'Source';
	text: (self class methodDict at: #glamourNavigationBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self glamourNavigationBrowser ]! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 14:23'!
glamourNavigationBrowser
	| browser |
	browser := GLMTabulator new.
	browser row: [ :r | r column: #one; column: #two; column: #three ]; row: #four.
	" note: we have demoTrees as elements (see display and children) and format this with either text or fullText "
	browser transmit to: #one; andShow: [ :a | a tree
		title: 'Tree';
		children: [ :t | t children ];
		format: [ :t | t text ] ].
	browser transmit from: #one; to: #two; andShow: [ :a | a list
		title: 'Children from tree';
		display: #children;
		format: [ :child | child text, ' (', child totalCount asString ,')'] ].
	browser transmit from: #one; to: #three; andShow: [ :a | a text
		title: 'Details from tree';
		format: #fullText ].
	browser transmit from: #two; to: #three; andShow: [ :a | a text
		title: 'Details from list';
		format: #fullText ].
	browser transmit from: #one; to: #four; andShow: [ :a | a mondrian
		title: 'Mondrian from tree element';
		painting: [ :view :element | element showOn: view ] ].
	browser transmit from: #two; to: #four; andShow: [ :a | a mondrian
		title: 'Mondrian from list element';
		painting: [ :view :element | element showOn: view ] ].
	browser startOn: DemoTree demo.
	^browser
! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 15:51'!
glamourPanes
	^TutorialCustomAndText new
	title: 'Panes';
	textTitle: 'Source';
	text: (self class methodDict at: #glamourPanesBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self glamourPanesBrowser ]! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 14:06'!
glamourPanesBrowser
	| browser |
	browser := GLMTabulator new.
	browser row: [ :r | r column: #one; column: #two; column: #three ]; row: #four.
	browser transmit to: #three; andShow: [ :a | a text 
		title: 'Text';
		display: 'This is a simple text pane.'].
	browser transmit to: #two; andShow: [ :a | a list
		title: 'List';
		display: (0 to: 10) ].
	browser transmit to: #one; andShow: [ :a | a tree
		title: 'Tree';
		display: DemoTree demo;
		children: #children;
		format: #text ].
	browser transmit to: #four; andShow: [ :a | a mondrian
		title: 'Mondrian';
		painting: [ :view | DemoTree demo showOn: view ] ].
	browser startOn: self.
	^browser
! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 15:51'!
glamourParameters
	^TutorialCustomAndText new
	title: 'Parameters';
	textTitle: 'Source';
	text: (self class methodDict at: #glamourParametersBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self glamourParametersBrowser ]! !

!SpaTutorial methodsFor: 'glamour' stamp: 'DiegoLont 6/29/2012 14:18'!
glamourParametersBrowser
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #one; andShow: [ :a | a list 
		title: 'Short' ]. "Implicit"
	browser transmit to: #two; andShow: [ :a | a list
		title: 'Symbols';
		display: #yourself; "Show the object itself"
		format: #asString ]. "Format is optional here"
	browser transmit to: #three; andShow: [ :a | a list
		title: 'Blocks';
		display: [ :modelElement | modelElement ]; "Allows calculation what to show"
		format: [ :node | node asString ] ].
	browser startOn: self parameterElements. " An array of 6 strings "
	^browser
! !

!SpaTutorial methodsFor: 'browsers' stamp: 'StephanEggermont 6/28/2012 19:38'!
introduction
	^TutorialText new
	title: 'Introduction';
	text: 
'MOOSE is an environment for data and code reengineering.
In this workshop we hope to show you the power of visualizing
your systems and help you getting started with MOOSE. We''ll show
you Glamour, Mondrian and Eyesee, three of the many parts.'! !

!SpaTutorial methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 17:36'!
layouts
	^#(sugiyamaLayout treeLayout bulletTreeLayout)! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:46'!
mondrian
	^TutorialText new
	title: 'Mondrian';
	text: 
'Mondrian is a framework to draw and layout nodes and edges.
Nodes can be different shapes and can be nested';
	children: #( mondrianExamples mondrianConcepts mondrianExercises)! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:22'!
mondrianConcepts
	^TutorialText new
	title: 'Concepts';
	text: 
'- Nodes
- Edges
- Layout
';
	children: #( mondrianNodes mondrianEdges mondrianLayout )! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:32'!
mondrianEdges
	^TutorialCustomAndText new
	title: 'Edges';
	textTitle: 'Source';
	text: (self class methodDict at: #mondrianLayoutBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self mondrianLayoutBrowser ]! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:25'!
mondrianExamples
	^TutorialText new
	title: 'Examples';
	text: 
'Mondrian is all about art. So let''s look at some art first

Example 1 shows some information about the system quality of the code for this workshop

Example 2 is a mondrian number tree.

Example 3 shows some UML diagrams

In a MOOSE image, the Mondrian Easel provides a good environment to try out different visualizations ';
	children: #( mondrianMySystemQuality mondrianNumberTree mondrianUMLObject mondrianUMLEggrace )! !

!SpaTutorial methodsFor: 'mondrianExercises' stamp: 'StephanEggermont 6/29/2012 18:43'!
mondrianExercise1
	^TutorialExercise new
	title: 'Commit size';
	textTitle: 'Source';
	text: (SpaMondrianExercise methodDict at: #exercise1) getSource;
	assignment: '
Do the different committers work in a similar way?
Are commits small or large?
	
Let''s find out.

In the Commit size pane,  a node is shown for each commit done by the committer. 
Let''s make the width of the node represent the number of elements of the commit.
Start by setting the node shapes

view shape rectangle width: [:commit | commit elements size * 3 ]

The commits are now layed out in a horizontal line. Layout in a grid might provide more insight
End the painting by setting the layout 

view gridLayout

	 ';
	smalltalkClass: SpaMondrianExercise;
	target: ERModel default;
	presentation: SpaMondrianExercise new exercise1! !

!SpaTutorial methodsFor: 'mondrianExercises' stamp: 'StephanEggermont 6/29/2012 18:12'!
mondrianExercises
	^TutorialText new
	title: 'Exercises';
	text: 
'1 Commit size / commit

';
	children: #( mondrianExercise1 )! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:41'!
mondrianLayout
	^TutorialCustomAndText new
	title: 'Layout';
	textTitle: 'Source';
	text: 'view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view perform: element. "#sugiyamaLayout or #treeLayout or #bulletTreeLayout"';
	presentation: [ self mondrianLayoutBrowser ]! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:40'!
mondrianLayoutBrowser
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two span: 3.
	" note: we have demoTrees as elements (see display and children) and format this with either text or fullText "
	browser transmit to: #one; andShow: [ :a | a list
		title: 'Layout';
		format: [ :t | t asString ] ].
	browser transmit from: #one; to: #two; andShow: [ :a | a mondrian
		title: 'Collection subclasses';
		painting: [ :view :element |
			view nodes: Collection withAllSubclasses.
			view edgesFrom: #superclass.
			view perform: element.  ] ].
	browser startOn: self layouts.
	^browser
! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:52'!
mondrianMySystemQuality
	^TutorialCustom new
	title: 'System Quality ';
	presentation: [	| browser |
	browser := GLMTabulator new.
	browser 
		row: #details.
	browser transmit to: #details; andShow: [ :a |
		a mondrian
			title: 'Complexity';
			painting: [:view|
"Each node is a class, edges designate inheritance.
Height is linear to the number of method the class defines.
Width is linear to the number of variables the class defines.
Color color is linear to the number of lines of code of the class.
The darkest node designates the class that has the highest number of lines of code"
				| packages classes |
				packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
				classes := OrderedCollection new.
				packages do: [ :p | classes addAll: p classes ].
				view interaction action: #browse.
				view shape rectangle
					width: [:cls | cls instVarNames size * 3];
					height: [:cls | cls methods size ];
					linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]] within: classes.
				view nodes: classes.
				view edgesFrom: #superclass.
				view treeLayout].
		a mondrian 
			title: 'Uncategorized methods';
			painting: [:view |
"This visualization is useful to track down 'as yet unclassified' method categories. This is widely recognized as a bad Smalltalk practice to have such a method category" 

				| packages classes |
				packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
				classes := OrderedCollection new.
				packages do: [ :p | classes addAll: p classes ].

				view shape rectangle 
					size: 20;
				if: [ :cls | cls organization categories includesAnyOf: #(#'as yet unclassified ' #'as yet unclassified') ] fillColor: Color red.
	
				view interaction action: #browse.
				view nodes: classes.
				view edgesFrom: #superclass.
				view treeLayout].
		a mondrian 
			title: 'Distribution map';
			painting: [:view |
		"Simple example of a distribution map. 
		Green methods are short. Orange are long. Red are very long"
				| classes d packages  |
				packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
				classes := OrderedCollection new.
				packages do: [ :p | classes addAll: p classes ].				
				d := IdentityDictionary new.
				classes do: [:aClass | aClass methods do: [:m | d at: m put: m getSource lineCount ] ].

				view shape rectangle withoutBorder.
				view nodes: classes forEach: [ :each |
					view shape label.
					view node: each.
					view node: each forIt: [
						view shape rectangle size: 12;
							if: [:m | (d at: m) < 5 ] fillColor: Color green;
							if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
							if: [:m | (d at: m) >= 25 ] fillColor: Color red.
						view nodes: (each methods sortedAs: [:m | (d at: m) ]).
						view gridLayout gapSize: 2 ].
						view verticalLineLayout ].
	
				view gridLayout]].
		
	browser startOn: self.
	browser] ! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'StephanEggermont 6/29/2012 17:32'!
mondrianNodes
	^TutorialCustomAndText new
	title: 'Nodes';
	textTitle: 'Source';
	text: (self class methodDict at: #mondrianLayoutBrowser) getSource;
	smalltalkClass: self class;
	presentation: [ self mondrianLayoutBrowser ]! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'DiegoLont 6/29/2012 16:39'!
mondrianNumberTree
	^TutorialCustom new
	title: 'Numbers in Mondrian tree ';
	presentation: [	| browser items |
	browser := GLMTabulator withStatusbar.
	items := 50.
	browser act: [:b | 
		items := 10.
		(b paneNamed: #one) presentations first update ] entitled: 'Update'.
	browser act: [:b | 
		(b paneNamed: #one) inspect ] entitled: 'Inspect'.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a mondrian 
			title: 'Numbers in Mondrian tree';
			painting: [:view :number | 
			view shape label.
			view nodes: (1 to: items ).
			view edgesFrom: [:x | x // 3 ].
			view horizontalTreeLayout ]].
	browser transmit to: #two; from: #one; andShow: [ :a |
		a mondrian 
			title: 'Numbers in Mondrian list';
			painting: [:view :number |
				view shape rectangle width: 20; text: #printString; withoutBorder.
				view nodes: (1 to: number).
				view gridLayout ]].
	browser startOn: 10.
	browser]! !

!SpaTutorial methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:34'!
mondrianPackage: aPackage
	(aPackage packageName beginsWith: 'SPAWorkshop') ifTrue: [ ^true ].
	(aPackage packageName beginsWith: 'EggRace') ifTrue: [ ^true ].
	(aPackage packageName beginsWith: 'TutorialBrowser') ifTrue: [ ^true ].
	^false.! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'DiegoLont 6/29/2012 16:41'!
mondrianUMLEggrace
	^TutorialCustom new
	title: 'UML Egg race';
	presentation: [	| browser |
	browser := GLMTabulator new.
	browser 
		row: #details.
	browser transmit to: #details; andShow: [ :a |
		a mondrian
			title: 'Egg race';
			painting: [:view|
			"Resize the easel after generating"
				view shape umlClass.
				view nodes: self eggRaceClasses forEach: [:cls | 
					view shape label.
					view nodes: ((cls methods collect: #selector )sort: [:x :y | x < y]).
					view verticalLineLayout ].

				 	view shape: (MOArrowedOrthoVerticalLineShape new).
				view edgesFrom: #superclass.
				view treeLayout]].
	browser startOn: self.
	browser]  ! !

!SpaTutorial methodsFor: 'mondrian' stamp: 'DiegoLont 6/29/2012 16:39'!
mondrianUMLObject
	^TutorialCustom new
	title: 'Single responsibility principle ';
	presentation: [	| browser |
	browser := GLMTabulator new.
	browser 
		row: #details.
	browser transmit to: #details; andShow: [ :a |
		a mondrian
			title: 'Single Responsibility Principle';
			painting: [:view|
			"Resize the easel after generating"
				view shape umlClass.
				view nodes: (Array with: Object) forEach: [:cls | 
					view shape label.
					view nodes: ((cls methods collect: #selector )sort: [:x :y | x < y]).
					view verticalLineLayout ].

				 	view shape: (MOArrowedOrthoVerticalLineShape new).
				view edgesFrom: #superclass.
				view treeLayout]].
	browser startOn: self.
	browser]  ! !

!SpaTutorial methodsFor: 'glamour' stamp: 'StephanEggermont 7/1/2012 17:29'!
moreExamples
	^TutorialCustom new
	title: 'More examples';
	presentation: [|tmp| 
		tmp := TutorialExamplesBrowser new browser.
		tmp startOn: self.
		tmp ]! !

!SpaTutorial methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:14'!
parameterElements
	^#(
		'Parameters in glamour browsers are polymorphic'
		'One can use symbols'
		'One can use objects'
		'One can use blocks'
		'This probably requires some explanation'
		'So here we display all things in different styles'
	)! !

!SpaTutorial methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 12:08'!
spaTutorial
	^TutorialText new
	title: 'Legacy Data and Code Visualization with MOOSE';
	text: 
'
Visualize, make sense, transform.


By: 
  Willem van den Ende @MostAlive
  Stephan Eggermont @StOnSoftware

At: 
  SPA2012'! !

!SpaTutorial methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 12:02'!
thanks
	^TutorialText new
	title: 'Thanks';
	text: 
'This workshop uses code written for the egg race at SPA2011.

We would like to thank:
- Diego Lont for working on the egg race code, the data conversion project and this workshop.
- Michael Feathers for the scripts and data from the git repositories.
- Marc Evers & Robert Chatley for the egg race inspiration. 

'! !

!SpaTutorial methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 12:06'!
tutorial
	^#(spaTutorial
	introduction
	
	glamour
	mondrian
	eyesee
	
	furtherReading
	thanks)! !

Object subclass: #DemoTree
	instanceVariableNames: 'text children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Tutorial'!

!DemoTree class methodsFor: 'instance creation' stamp: 'DiegoLont 6/29/2012 11:12'!
demo
	^DemoTree on: 10! !

!DemoTree class methodsFor: 'instance creation' stamp: 'DiegoLont 6/29/2012 11:12'!
on: anInteger
	^self basicNew
		initialize: anInteger;
		yourself! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:14'!
children
	^ children ifNil: [ children := OrderedCollection new ]! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:14'!
children: anObject
	children := anObject! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:47'!
fullText
	^String streamContents: [ :s |
		s nextPutAll: 'Text: ';
			nextPutAll: self text;
			lf.
		s nextPutAll: 'Children: ';
			nextPutAll: self children asString;
			lf ]! !

!DemoTree methodsFor: 'initialization' stamp: 'DiegoLont 6/29/2012 11:16'!
initialize: anInteger
	self initialize.
	self text: anInteger asString.
	0 to: (anInteger -1) do: [ :each | self children add: (self class on: each) ]! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:37'!
showOn: aView
	aView shape rectangle withoutBorder.
	aView nodes: self children forEach: [ :each |
		aView shape label.
		aView node: each.
		aView node: each forIt: [
			aView shape rectangle size: 12;
				fillColor: Color green.
			aView nodes: each children.
			aView gridLayout gapSize: 2 ].
		aView verticalLineLayout ].
	aView gridLayout! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:14'!
text
	^ text! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:14'!
text: anObject
	text := anObject! !

!DemoTree methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:24'!
totalCount
	^(self children inject: 1 into: [ :sum :child | sum + child totalCount ])! !

Object subclass: #SpaEyeseeExercise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Exercise'!

!SpaEyeseeExercise methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 7/1/2012 13:14'!
exercise1
	| browser |
	browser := GLMTabulator new
		row: [ :r | r column: #project; column: #element];
		row: #three;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a list
			title: 'Projects';
			display: [ :model | model projects ]].
	browser transmit to: #element; from: #project; andShow: [ :a |
		a list
			title: 'Team';
			allowDeselection; 
			display: [ :project | project committers ] ].
	browser transmit from: #element; to: #three; andShow: [:a |
	       a eyesee
			title: 'Commit size';
			diagram: [:renderer :x |
	                       renderer verticalBarDiagram
						y: #yourself;
						models: (x commits collect: [:commit | commit elements size]);
						width: 200;
						height: 150;
						baseAxisLine.
					renderer interaction popupText: #yourself ]].
	^browser startOn: ERModel default.
! !

Object subclass: #SpaGlamourExercise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Exercise'!

!SpaGlamourExercise methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 15:16'!
exercise1
	| browser |
	browser := GLMTabulator new
		row: #project;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	^browser startOn: ERModel default! !

!SpaGlamourExercise methodsFor: 'browsers' stamp: 'StephanEggermont 7/1/2012 17:37'!
exercise2
	| browser |
	browser := GLMTabulator new
		column: #project; 
		column: [:c | c row: #info; row: #element] ;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	browser transmit to: #element; from: #project; andShow: [ :a |
		a list
			title: 'Team';
			allowDeselection  ;
			display: [ :project | project committers ] ].
	browser transmit to: #info; from: #project; andShow: [ :a |
		a text
			title: 'Project info';
			display: [ :project | project info ] ].

	^browser startOn: ERModel default ! !

!SpaGlamourExercise methodsFor: 'browsers' stamp: 'StephanEggermont 6/29/2012 18:02'!
exercise3
	| browser |
	browser := GLMTabulator new
		row: [ :r | r column: #project; column: #element; column: #info ];
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	browser transmit to: #element; from: #project; andShow: [ :a |
		a list
			title: 'Team';
			allowDeselection; 
			display: [ :project | project committers ] ].
	browser transmit to: #info; from: #project; andShow: [ :a |
		a text
			title: 'Project info';
			display: [ :project | project info ] ].
	^browser startOn: ERModel default! !

!SpaGlamourExercise methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 16:21'!
exercise4
	| browser |
	browser := GLMTabulator new
		row: [ :r | r column: #project; column: #file; column: #info ];
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	browser transmit to: #file; from: #project; andShow: [ :a |
		a tree
			title: 'Files';
			allowDeselection; 
			display: [ :project | project entries ];
			children: [ :element | element children ] ].
	browser transmit to: #info; from: #project; andShow: [ :a |
		a text
			title: 'Project info';
			display: [ :project | project info ] ].
	browser transmit to: #info; from: #file; andShow: [ :a |
		a text
			title: 'File info';
			display: [ :file | file info ] ].
	^browser startOn: ERModel default! !

!SpaGlamourExercise methodsFor: 'browsers' stamp: 'DiegoLont 6/29/2012 15:33'!
exercise5
	| browser |
	browser := GLMTabulator new
		row: #project;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	^browser startOn: ERModel default! !

Object subclass: #SpaMondrianExercise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Exercise'!

!SpaMondrianExercise methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 6/29/2012 18:52'!
exercise1
	| browser |
	browser := GLMTabulator new
		row: [:r | r column:  #project; column: #element];
		row: #commitsize;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ]].
	browser transmit to: #element; from: #project; andShow: [ :a |
		a list
			title: 'Team';
			allowDeselection; 
			display: [ :project | project committers ] ].
	browser transmit to: #commitsize; from: #element; andShow: [:a |
		a mondrian
			title: 'Commit sizes';
			painting: [:view :element |
				view nodes: element commits.
				]].
	^browser startOn: ERModel default! !

Object subclass: #TestBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPAWorkshop-Tutorial'!

!TestBrowser class methodsFor: 'public' stamp: 'StephanEggermont 6/29/2012 00:31'!
diff
	| browser |
	browser := GLMTabulator new.
	browser row: [:r | r column: #methods; column: #version1; column: #version2];
		row: #diff.
	browser title: 'Version Diff'.
	browser transmit to: #methods; andShow: [ :a | 
		a list
			display: [:methods | methods ];
			format: [:method | method printString]].
	^browser startOn: SpaTutorial selectors.! !

!TestBrowser class methodsFor: 'public' stamp: 'StephanEggermont 6/28/2012 22:22'!
open
	| browser |
	browser := GLMTabulator new.
	browser column: #text.
	browser title: 'Rich text'.
	browser transmit to: #text; andShow: [ :a | 
		a text 
			display: [:par | (Text string: 'Bla' attribute: (TextFontChange font4)) ];
		allowNil].
	^browser startOn: browser! !
